clear all;
[X, Y] = meshgrid(-50:0.1:50, -10:0.2:10);
prx = zeros(101, 1001);
prxo = zeros(101, 1001);
pry = zeros(101, 1001);
nax = zeros(101, 1001);
nay = zeros(101, 1001);
sev = zeros(101, 1001);
Z = zeros(101, 1001);
ZS = zeros(101, 1001);
c = zeros(1001);
r = zeros(101);
ax0 = 0;
sdax = 0.7;
ay0 = 0;
sday = 0.2;

ts = 2;

SVX = 30;
NVX = 30;
SVY = 1;
NVY = 1; %Initial conditions of the subject and neighbourign vehicle
for c = 1:1000
    for r = 1:100
        Z(r, c) = (normpdf((2/(ts^2)) * (X(r, c) + (SVX - NVX) * ts), ax0, sdax)) * (normpdf((2/(ts^2)) * (Y(r, c) + (SVY - NVY) * ts), ay0, sday));
        TX(r, c) = (normpdf((2/(ts^2)) * (X(r, c) + (SVX - NVX) * ts), ax0, sdax));
        TY(r, c) = (normpdf((2/(ts^2)) * (Y(r, c) + (SVY - NVY) * ts), ay0, sday));
    end
end
zlev = 0.1:0.4:1;
contour(X, Y, Z, zlev, 'showtext', 'on');
set(gca, 'fontsize', 20);
xlim([-10, 10])
ylim([-5, 5])
xlabel({'[d] Longitudinal spacing (m)'});
ylabel({'Lateral spacing (m)'});
colorbar;
