function [PROB,OVERLAP]= C_PROB(S_x,S_y,S_vx, S_vy, N_x, N_y, N_vx, N_vy, Singlestep)
%N_x=0;N_vx=19;N_y=0;N_vy= 0;
%S_x =-30;S_y=0;S_vx=28; S_vy= -0.5;
%Singlestep = 3;
OVERLAP=0;

max_long_acc = 5;max_lat_acc = 5;max_brake_acc = 5; %vehicle behaviour constraints;

[NX, NY] = reachable(N_x,N_y,N_vx,N_vy,Singlestep,max_long_acc,max_brake_acc,max_lat_acc);  %neighbour vehicle
%[RX, RY] = reachable(S_x,S_y,S_vx,S_vy,Singlestep,0,0,0);
[RX, RY] = reachable(S_x,S_y,S_vx,0,Singlestep,0,0,0);%subject vehicle
L=4; % length of vehicle
W=2;% width of vehicle
RS_Xlimit= [RX(1)-L RX(1)+L];
RS_Ylimit = [RY(1)+W  RY(1)-W];
SX = RS_Xlimit([1 1 2 2 ]);
SY = RS_Ylimit([1 2 2 1 ]);
reachbleN= polyshape([NX], [NY]);
predictedS= polyshape([SX], [SY]);
cPO=intersect(reachbleN,predictedS);
C_ax_max= ((max(cPO.Vertices(:,1))-N_x)-N_vx*Singlestep)*(2/(Singlestep^2));
C_ax_min= ((min(cPO.Vertices(:,1))-N_x)-N_vx*Singlestep)*(2/(Singlestep^2));%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
length=size(cPO.Vertices,1);
C_ay= zeros(length, 1);C_ax= zeros(length, 1);
for i = 1:length%(collisionPolygon.Vertices) 
    C_ay(i,1)= ((cPO.Vertices(i,2)-N_y)-N_vy*Singlestep)*(2/(Singlestep^2));
    C_ax(i,1)= ((cPO.Vertices(i,1)-N_x)-N_vx*Singlestep)*(2/(Singlestep^2));
end

%finding the integral bound points A1, A2, A3 and A4: A3 and A4 are
%necessary for the pentagon and hexagon
 A1 =zeros(1, 2); A2 = [];A3 = [];A4 = [];coA=[];
 B1 =zeros(1, 2); B21 = zeros(1, 2); B22 = zeros(1, 2);B3 = [];B4 = [];
if length
    coA= polyshape([C_ax], [C_ay]);
    %finding A1
    [MIN_AX,I]= min(coA.Vertices(:,1));
    A1 = coA.Vertices(I,:);
    B1 = A1;
    Q1 = find(coA.Vertices(:,1)== MIN_AX);
    if size(Q1,1)>1
        if coA.Vertices(Q1(1),2)> coA.Vertices(Q1(2),2)
            A1 = coA.Vertices(Q1(1),:);
            B1 = coA.Vertices(Q1(2),:);
        else
            A1 = coA.Vertices(Q1(2),:);
            B1 = coA.Vertices(Q1(1),:);
        end
    end

    %finding A2
    [MAX_AX]= max(coA.Vertices(:,1));
    A2=[MAX_AX A1(1,2)];
   
    Q2 = find(coA.Vertices(:,1)== MAX_AX);
     if size(Q2,1)==1
        B21 = coA.Vertices(Q2(1),:);
        B22 = coA.Vertices(Q2(1),:);
     else
        if coA.Vertices(Q2(1),2)> coA.Vertices(Q2(2),2)
        B21 = coA.Vertices(Q2(1),:);
        B22 = coA.Vertices(Q2(2),:);
        else
        B22 = coA.Vertices(Q2(1),:);
        B21 = coA.Vertices(Q2(2),:);  
        end
     end

    %finding A3
    if (size(coA.Vertices,1)>4)
        Q3 = find((coA.Vertices(:,1)~= MIN_AX)& (coA.Vertices(:,1)~= MAX_AX));
        A3= [coA.Vertices(Q3(1,1),1) A1(1,2)];
        B3= coA.Vertices(Q3(1,1),:);
        if (size(coA.Vertices,1)>5) %finding A4
            A4= [coA.Vertices(Q3(2,1),1) A1(1,2)];
            B4= coA.Vertices(Q3(2,1),:);
        end
        
        
    end 
end
%finding the double integral over the collision acceleration domain
if (A2)
    OVERLAP=1;
end
PROB=0;
fun = @(x,y) normpdf(x,0,2).*normpdf(y,0,0.2);% 0----?---
if (A4)
    M4= (B4(1,2)-A1(1,2))/(B4(1,1)-A1(1,1)); %slope of line connecting B1 and B4
    M3= (B3(1,2)-A1(1,2))/(B3(1,1)-A1(1,1)); %slope of line connecting B1 and B3
    if A1(1,2)== B1(1,2)
       ymax4 = @(x) M4*(x - A1(1,1))+A1(1,2);       
       INT4= integral2(fun,A1(1,1),A4(1,1),A1(1,2),ymax4);
       ymax3 = @(x) M3*(x - A1(1,1))+A1(1,2);       
       INT3= integral2(fun,A1(1,1),A3(1,1),A1(1,2),ymax3);
       INT21= integral2(fun,A4(1,1),A2(1,1),A4(1,2),B4(1,2));
       INT22= integral2(fun,A3(1,1),A2(1,1),A3(1,2),B3(1,2));
        1001;
       PROB=abs(INT22)+abs(INT21)+abs(INT3)+abs(INT4);
      
    elseif M4 < 0
       M4= (B4(1,2)-B1(1,2))/(B4(1,1)-B1(1,1));
       ymax4 = @(x) M4*(x - B1(1,1))+B1(1,2);       
       INT4= integral2(fun,B1(1,1),A4(1,1),A1(1,2),ymax4);
       ymax3 = @(x) M3*(x - A1(1,1))+A1(1,2);       
       INT3= integral2(fun,A1(1,1),A3(1,1),A1(1,2),ymax3);
       INT21= integral2(fun,A4(1,1),A2(1,1),A4(1,2),B4(1,2));
       INT22= integral2(fun,A3(1,1),A2(1,1),A3(1,2),B3(1,2));
         1002;
       PROB=abs(INT22)+abs(INT21)+abs(INT3)+abs(INT4);
       
    elseif M4>0 %B3 is lower
       M3= (B3(1,2)-B1(1,2))/(B3(1,1)-B1(1,1));
       ymax4 = @(x) M4*(x - A1(1,1))+A1(1,2);       
       INT4= integral2(fun,A1(1,1),A4(1,1),A1(1,2),ymax4);
       ymax3 = @(x) M3*(x - B1(1,1))+B1(1,2);       
       INT3= integral2(fun,B1(1,1),A3(1,1),A1(1,2),ymax3); %ymin is fixed a A1 always
       INT21= integral2(fun,A4(1,1),A2(1,1),A4(1,2),B4(1,2));
       INT22= integral2(fun,A3(1,1),A2(1,1),A3(1,2),B3(1,2));
         1003;
       PROB=abs(INT22)+abs(INT21)+abs(INT3)+abs(INT4);
    end
    
elseif A3
    M3= (B3(1,2)-A1(1,2))/(B3(1,1)-A1(1,1)); %slope of line connecting B1 and B3
    if A1(1,2)== B1(1,2)
       ymax3 = @(x) M3*(x - A1(1,1))+A1(1,2); 
       INT3= integral2(fun,A1(1,1),A3(1,1),A1(1,2),ymax3);
       if A1(1,2) < B3(1,2)             
           M2=(B22(1,2)-A1(1,2))/(B22(1,1)-A1(1,1)); %slope of line connecting B1 and B3
           ymax2 = @(x) M2*(x - A1(1,1))+A1(1,2);
           INT21= integral2(fun,A3(1,1),A2(1,1),A3(1,2),B3(1,2));
           INT22= integral2(fun,A1(1,1),A2(1,1),A1(1,2),ymax2);
             1004;
           PROB=abs(INT22)+abs(INT21)+abs(INT3);
       else
           M2=(B21(1,2)-A1(1,2))/(B21(1,1)-A1(1,1)); %slope of line connecting B1 and B3
           ymax2 = @(x) M2*(x - A1(1,1))+A1(1,2);
           INT21= integral2(fun,A1(1,1),A2(1,1),A1(1,2),ymax2);
           INT22= integral2(fun,A3(1,1),A2(1,1),A3(1,2),B3(1,2));
             1005;
           PROB=abs(INT22)+abs(INT21)+abs(INT3);
       end
    elseif M3 > 0
      
       ymax3 = @(x) M3*(x - A1(1,1))+A1(1,2);       
       INT3= integral2(fun,A1(1,1),A3(1,1),A1(1,2),ymax3);
       INT21= integral2(fun,A3(1,1),A2(1,1),A3(1,2),B3(1,2));
       INT22= integral2(fun,A1(1,1),A2(1,1),A1(1,2),B1(1,2));
         1006;
       PROB=abs(INT22)+abs(INT21)+abs(INT3);
    elseif M3 < 0
       M3= (B3(1,2)-B1(1,2))/(B3(1,1)-B1(1,1));
       ymax3 = @(x) M3*(x - B1(1,1))+B1(1,2);       
       INT3= integral2(fun,A1(1,1),A3(1,1),A1(1,2),ymax3); %ymin is fixed a A1 always
       INT22= integral2(fun,A3(1,1),A2(1,1),A3(1,2),B3(1,2));
         1007;
       PROB=abs(INT22)+abs(INT3);
    end
elseif A1
    if A1(1,2)== B1(1,2)
      M22= (B21(1,2)-A1(1,2))/(B21(1,1)-A1(1,1));
      M21= (B22(1,2)-A1(1,2))/(B22(1,1)-A1(1,1));
      ymax22 = @(x) M22*(x - A1(1,1))+A1(1,2); 
      ymax21 = @(x) M21*(x - A1(1,1))+A1(1,2); 
      INT21= integral2(fun,A1(1,1),A2(1,1),A1(1,2),ymax21);
      INT22= integral2(fun,A1(1,1),A2(1,1),A1(1,2),ymax22);
        1008;
      PROB=abs(INT22)+abs(INT21);
    else
      M22= (B21(1,2)-A1(1,2))/(B21(1,1)-A1(1,1));
      M21= (B22(1,2)-B1(1,2))/(B22(1,1)-B1(1,1));
      ymax22 = @(x) M22*(x - A1(1,1))+A1(1,2); 
      ymax21 = @(x) M21*(x - B1(1,1))+B1(1,2); 
      INT21= integral2(fun,A1(1,1),A2(1,1),A1(1,2),ymax21);
      INT22= integral2(fun,A1(1,1),A2(1,1),A1(1,2),ymax22);
        1009;
      PROB=abs(INT22)+abs(INT21);
    end
      
end  

end


%end