function [xreach, yreach]= reachable(X,Y,VX,VY,TIME, AX_MAX, BRAKE_MAX, AY_MAX)
%AX_MAX=5; % maximum forward acceleration
%AY_MAX=5; %maximum lateral acceleration postive to left
AX_MIN = max(-BRAKE_MAX,-VX/TIME); % ensure no backward movement 
max_steer = 0.17; % tan(max steer angle)

%            * C This is the reachable space trapezoid
%  A *
%  B *
%            * D

VX_MIN=VX+AX_MIN*TIME; %vx at A and B
VX_MAX=VX+AX_MAX*TIME; %vx at C and D

MIN_X=X+VX*TIME+0.5*AX_MIN*(TIME^2); % x of A and B
MAX_X=X+VX*TIME+0.5*AX_MAX*(TIME^2); % x of C and D


VY_MAX=max_steer*VX_MAX; AY_HOL_MAX = VY_MAX/TIME; % holonomic constraints
VY_MIN=max_steer*VX_MIN; AY_HOL_MIN = VY_MIN/TIME; % holonomic constraints

MIN_LEFT_Y = Y+VY*TIME+ 0.5*(TIME^2)*min(AY_MAX,VY_MIN/TIME); % y of A 
MIN_RIGHT_Y = Y+VY*TIME+ 0.5*(TIME^2)*max(-AY_MAX,-VY_MIN/TIME); % y of B 
MAX_LEFT_Y = Y+VY*TIME+ 0.5*(TIME^2)*min(AY_MAX,VY_MAX/TIME); % y of C 
MAX_RIGHT_Y = Y+VY*TIME+ 0.5*(TIME^2)*max(-AY_MAX,-VY_MAX/TIME);  % y of D 
%Z=[MAX_X MIN_X MIN_LEFT_Y MIN_RIGHT_Y MAX_LEFT_Y MAX_RIGHT_Y];

xlimit = [MIN_X MAX_X];
ylimit = [MIN_LEFT_Y MIN_RIGHT_Y MAX_RIGHT_Y MAX_LEFT_Y];
xreach = xlimit([1 1 2 2 ]);
yreach = ylimit([1 2 3 4 ]);

if MIN_LEFT_Y == MIN_RIGHT_Y
xreach = xlimit([1 2 2 ]);
yreach = ylimit([1 3 4 ]);
end 
% mapshow(xreach,yreach,'DisplayType','polygon','LineStyle','none')
% title('????????')
end