clear;
% Set the input limits for ego and neighbour velocity
velocityRange(1)=5; %from 
velocityRange(2)=16; % till
numberofPoints = velocityRange(2)-velocityRange(1)+1; % set the number of points in the range

% Set the input space for ego and neighbour velocity
Vego= linspace(velocityRange(1),velocityRange(2),numberofPoints);
Vneighbour = linspace(velocityRange(1),velocityRange(2),numberofPoints);

% initialise the result struct
result =[];
warningtime_TTC = zeros(numberofPoints,numberofPoints);
warningtime_PDRF = zeros(numberofPoints,numberofPoints);
RISK_MAX= zeros(numberofPoints,numberofPoints);
RISK_MAX_2= zeros(numberofPoints,numberofPoints);
RISK_MAX_3= zeros(numberofPoints,numberofPoints);
RISK_MAX_4= zeros(numberofPoints,numberofPoints);
RISK_MAX_5= zeros(numberofPoints,numberofPoints);
CRASHEVENT= zeros(numberofPoints,numberofPoints);
FALSE_NEGATIVE_COUNTER_iTTC=zeros(numberofPoints,numberofPoints);
FALSE_NEGATIVE_FLAG_iTTC=zeros(numberofPoints,numberofPoints);
FALSE_NEGATIVE_COUNTER_PDRF=zeros(numberofPoints,numberofPoints);
FALSE_NEGATIVE_FLAG_PDRF=zeros(numberofPoints,numberofPoints);
FALSE_POSITIVE_COUNTER_iTTC=zeros(numberofPoints,numberofPoints);
FALSE_POSITIVE_COUNTER_PDRF=zeros(numberofPoints,numberofPoints);
TRUE_POSITIVE_COUNTER_iTTC=zeros(numberofPoints,numberofPoints);
TRUE_POSITIVE_COUNTER_PDRF=zeros(numberofPoints,numberofPoints);
TRUE_NEGATIVE_COUNTER_iTTC=zeros(numberofPoints,numberofPoints);
TRUE_NEGATIVE_COUNTER_PDRF=zeros(numberofPoints,numberofPoints);
iTTC_MAX= zeros(numberofPoints,numberofPoints);
flag_TTC_False=0;
flag_PDRF_False=0;
for i=1:numberofPoints
    for j=1:numberofPoints
        % index of the result =  i-1+j
        % 1,2,3,...1*numberofPoints
        % 1*numberofPoints+1,numberofPoints+2+....2*numberofPoints
        % 2*numberofPoints+1,... and so on
        [result((i-1)*numberofPoints+j).overlaptotal,...
            result((i-1)*numberofPoints+j).ptotal,...
            result((i-1)*numberofPoints+j).pdrf5,...
            result((i-1)*numberofPoints+j).sev,...
            result((i-1)*numberofPoints+j).maxPDRF,...
            result((i-1)*numberofPoints+j).evolution_PDRF,...
            result((i-1)*numberofPoints+j).pdrf1,...
            result((i-1)*numberofPoints+j).pdrf2,...
            result((i-1)*numberofPoints+j).pdrf,...
            result((i-1)*numberofPoints+j).pdrf4,...
            result((i-1)*numberofPoints+j).crashDetection,...
            result((i-1)*numberofPoints+j).maxITTC,...
            result((i-1)*numberofPoints+j).flagtime_TTC,...
            result((i-1)*numberofPoints+j).flagtime_PDRF]= KINETIC_PDRF(Vego(i),Vneighbour(j));
        RISK_MAX_5(i,j)=result((i-1)*numberofPoints+j).maxPDRF(5);
        RISK_MAX(i,j)=result((i-1)*numberofPoints+j).maxPDRF(1); % extracting just the PDRF risk for plotting 
        RISK_MAX_2(i,j)=result((i-1)*numberofPoints+j).maxPDRF(2);
        RISK_MAX_3(i,j)=result((i-1)*numberofPoints+j).maxPDRF(3);
        RISK_MAX_4(i,j)=result((i-1)*numberofPoints+j).maxPDRF(4);
        CRASHEVENT(i,j)=result((i-1)*numberofPoints+j).crashDetection(1); % extracting just the crash detection for plotting 
        iTTC_MAX(i,j)= result((i-1)*numberofPoints+j).maxITTC(1); % extracting just the minTTC for plotting 
        % crash
       if result((i-1)*numberofPoints+j).crashDetection(1,1)==1%there is a collision
            if result((i-1)*numberofPoints+j).flagtime_TTC >0%collision detected
            warningtime_TTC(i,j)= result((i-1)*numberofPoints+j).crashDetection(2,1)-result((i-1)*numberofPoints+j).flagtime_TTC;
                if warningtime_TTC(i,j)<0% time is later than the collision so it fails to detect the danger 
                   FALSE_NEGATIVE_COUNTER_iTTC(i,j)=1;
                   flag_TTC_False=flag_TTC_False+1;
                   FALSE_NEGATIVE_FLAG_iTTC(i,j)=1;
                else
                   TRUE_POSITIVE_COUNTER_iTTC(i,j)=1;
                end
            else% there is a collision but no detection
                FALSE_NEGATIVE_COUNTER_iTTC(i,j)=1;
                warningtime_TTC(i,j)=100;
            end
            if result((i-1)*numberofPoints+j).flagtime_PDRF >0%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            warningtime_PDRF(i,j)= result((i-1)*numberofPoints+j).crashDetection(2,1)-result((i-1)*numberofPoints+j).flagtime_PDRF;
                 if warningtime_PDRF(i,j)<0
                     warningtime_PDRF(i,j)=100; 
                   FALSE_NEGATIVE_COUNTER_PDRF(i,j)=1;
                   flag_PDRF_False=flag_PDRF_False+1;
                   FALSE_NEGATIVE_FLAG_PDRF(i,j)=1;
                 else
                   TRUE_POSITIVE_COUNTER_PDRF(i,j)=1; 
                 end
            else %flagtime_PDRF==0 there is no collision%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% PDRF belongs to this case
                FALSE_NEGATIVE_COUNTER_PDRF(i,j)=1;
                warningtime_PDRF(i,j)=100;
            end
       %no crash%%%%%%%%%%%%%%%%%%%%%%%%%%%%
       else %if result((i-1)*numberofPoints+j).crashDetection(1,1)==0
           if result((i-1)*numberofPoints+j).flagtime_TTC >0
            FALSE_POSITIVE_COUNTER_iTTC(i,j)=1;
            warningtime_TTC(i,j)=100;
           else
            TRUE_NEGATIVE_COUNTER_iTTC(i,j)=1;   
           end
           if result((i-1)*numberofPoints+j).flagtime_PDRF >0
            FALSE_POSITIVE_COUNTER_PDRF(i,j)=1;
            warningtime_PDRF(i,j)=100;
           else
            TRUE_NEGATIVE_COUNTER_PDRF(i,j)=1; 
           end
           warningtime_TTC(i,j)= 100; warningtime_PDRF(i,j)=100;
        end
  
    end
end
FALSE_NEGATIVE_TTC=nnz(FALSE_NEGATIVE_COUNTER_iTTC);
FALSE_NEGATIVE_PDRF=nnz(FALSE_NEGATIVE_COUNTER_PDRF);
FALSE_POSITIVE_TTC=nnz(FALSE_POSITIVE_COUNTER_iTTC);
FALSE_POSITIVE_PDRF=nnz(FALSE_POSITIVE_COUNTER_PDRF);
TRUE_NEGATIVE_TTC=nnz(TRUE_NEGATIVE_COUNTER_iTTC);
TRUE_NEGATIVE_PDRF=nnz(TRUE_NEGATIVE_COUNTER_PDRF);
TRUE_POSITIVE_TTC=nnz(TRUE_POSITIVE_COUNTER_iTTC);
TRUE_POSITIVE_PDRF=nnz(TRUE_POSITIVE_COUNTER_PDRF);
[pos(:,1),pos(:,2)]=find(FALSE_NEGATIVE_COUNTER_PDRF);