%clear all
function [overlaptotal,ptotal,pdrf5,sev,maxPDRF,evolution_PDRF, pdrf1, pdrf2, pdrf,pdrf4,crashDetection, max_iTTC,flagtime_TTC,flagtime_PDRF]= KINETIC_PDRF(egoVelocity, NeighbourVelocity)
[DATASET,crashDetection] = EventGenerator(egoVelocity, NeighbourVelocity);
% the xlsx file contains following columns
% 1) X: Longitudinal position of subject in m
% 2) Y: Lateral position of subject in m
% 3) VX: Longitudinal velocity of subject in m/s
% 4) VY: Lateral velocity of subject in m/s
% 5) Longitudinal position of leader in m
% 6) Lateral position of leader in m
% 7) Longitudinal velocity of leader in m/s
% 8) Lateral velocity of leader in m/s

duration= size(DATASET,1);
spacing= zeros(duration,1);TTC= zeros(duration,1);
% SMOOTHVY=smooth(DATASET(:,4),10);
% SMOOTHY=smooth(DATASET(:,2),10);

TTC_threshold = 3;     % danger flage if TTC below threshold
PDRF_threshold = 0.1; % danger flag if PDRF above threshold
flagtime_TTC=0;        % time when the danger flagged by TTC
flagtime_PDRF=0;        % time when the danger flagged by PDRF
p1= zeros(duration,1);
p2= zeros(duration,1);
p= zeros(duration,1);
p4= zeros(duration,1);
p5= zeros(duration,1);
sev=zeros(duration,1);
pdrf1=zeros(duration,1);
pdrf2=zeros(duration,1);
pdrf=zeros(duration,1);
pdrf4=zeros(duration,1);
pdrf5=zeros(duration,1);
prtime=zeros(duration,1);
sacceleration=zeros(duration,1);
for i= 1:duration
   [p(i,1),p(i,2)]= C_PROB(DATASET(i,1),DATASET(i,2),DATASET(i,3),DATASET(i,4),DATASET(i,5),DATASET(i,6),DATASET(i,7),DATASET(i,8),3);
   spacing(i,1)= (((DATASET(i,1)-(DATASET(i,5))).^2)).^0.5;
   sev(i,1)=0.5*1000*0.25*((((DATASET(i,3)-(DATASET(i,7))).^2)).^0.5);
   pdrf(i,1)=p(i,1)*sev(i,1);
   prtime(i,1)=i*0.1;
   TTC(1,1)=100;
   
   [p5(i,1),p5(i,2)]= C_PROB(DATASET(i,1),DATASET(i,2),DATASET(i,3),DATASET(i,4),DATASET(i,5),DATASET(i,6),DATASET(i,7),DATASET(i,8),0.5); 
   pdrf5(i,1)=p5(i,1)*sev(i,1);
   [p1(i,1),p1(i,2)]= C_PROB(DATASET(i,1),DATASET(i,2),DATASET(i,3),DATASET(i,4),DATASET(i,5),DATASET(i,6),DATASET(i,7),DATASET(i,8),1); 
   pdrf1(i,1)=p1(i,1)*sev(i,1);
   [p2(i,1),p2(i,2)]= C_PROB(DATASET(i,1),DATASET(i,2),DATASET(i,3),DATASET(i,4),DATASET(i,5),DATASET(i,6),DATASET(i,7),DATASET(i,8),2); 
   pdrf2(i,1)=p2(i,1)*sev(i,1);
   [p4(i,1),p4(i,2)]= C_PROB(DATASET(i,1),DATASET(i,2),DATASET(i,3),DATASET(i,4),DATASET(i,5),DATASET(i,6),DATASET(i,7),DATASET(i,8),4); 
   pdrf4(i,1)=p4(i,1)*sev(i,1);

   
   
   %calculate TTC
   if i>1
       sacceleration(i,1)=(DATASET(i,3)-DATASET(i-1,3))/0.1;
       if(DATASET(i,7)-DATASET(i,3)<0)&& (DATASET(i,6)>1.75)
       TTC(i,1)=(max(0,((DATASET(i,1)-(DATASET(i,5)))/(DATASET(i,7)-DATASET(i,3)))));
       else
           TTC(i,1)=100;
       end
   end
   if TTC(i,1)< TTC_threshold && (flagtime_TTC==0)
       flagtime_TTC= i*0.1; % detect the time when danger was flagged by TTC 
   end 
   
   if pdrf(i,1)> PDRF_threshold  && (flagtime_PDRF==0)%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
       flagtime_PDRF= i*0.1; % detect the time when danger was flagged by PDRF 
   end 
end
ptotal=[p5(:,1),p1(:,1),p2(:,1),p(:,1),p4(:,1)];
overlaptotal=[p5(:,2),p1(:,2),p2(:,2),p(:,2),p4(:,2)];
max_iTTC = 1/(min(TTC)); % calculating maximum inverse TTC
%for multiple time-steps

% for i= 1:duration 
%    [p1(i,1),p1(i,2)]= C_PROB(DATASET(i,1),DATASET(i,2),DATASET(i,3),DATASET(i,4),DATASET(i,5),DATASET(i,6),DATASET(i,7),DATASET(i,8),1); 
%    pdrf1(i,1)=p1(i,1)*sev(i,1);
%    [p2(i,1),p2(i,2)]= C_PROB(DATASET(i,1),DATASET(i,2),DATASET(i,3),DATASET(i,4),DATASET(i,5),DATASET(i,6),DATASET(i,7),DATASET(i,8),2); 
%    pdrf2(i,1)=p2(i,1)*sev(i,1);
%    [p4(i,1),p4(i,2)]= C_PROB(DATASET(i,1),DATASET(i,2),DATASET(i,3),DATASET(i,4),DATASET(i,5),DATASET(i,6),DATASET(i,7),DATASET(i,8),4); 
%    pdrf4(i,1)=p4(i,1)*sev(i,1);
% end
E(1)=1;
E(2)= fix(duration*0.25);
E(3)= fix(duration*0.5);
E(4)= fix(duration*0.75);
E(5)=duration;
maxPDRF= [max(pdrf1) max(pdrf2) max(pdrf) max(pdrf4) max(pdrf5)];
evolution_PDRF=[pdrf(E(1),1) pdrf(E(2),1) pdrf(E(3),1) pdrf(E(4),1) pdrf(E(5),1)];
%{
smooth_sacc= smooth(sacceleration(:,1),10);
figure 
subplot(3,2,1)
plot(prtime(:,1),SMOOTHY,'-k',prtime(:,1),DATASET(:,6),'--k','LineWidth',2)
set(gca,'fontsize',10)
xlabel({'[a] Time (s)'});
ylabel('Lateral position (m)');
legend(['Subject'],['Leader'])
xlim([0 duration*0.1]);
%ylim([0 2]);
subplot(3,2,2)
plot(prtime(:,1),sev,'-r','LineWidth',2)
set(gca,'fontsize',10)
xlabel({'[b] Time (s)'});
ylabel('Severity in Joules');
xlim([0 duration*0.1]);

subplot(3,2,3)
plot(prtime(:,1),p1(:,1),':k',prtime(:,1),p2(:,1),'-.b',prtime(:,1),p(:,1),'--r',prtime(:,1),p4(:,1),'-g','LineWidth',2)
set(gca,'fontsize',10)
xlabel({'[c] Time (s)'});
ylabel('Crash probability');
legend(['time step = 1s'],['time step = 2s'],['time step = 3s'],['time step = 4s'])
xlim([0 duration*0.1]);

subplot(3,2,4)
plot(prtime(:,1),pdrf1(:,1),':k',prtime(:,1),pdrf2(:,1),'-.b',prtime(:,1),pdrf(:,1),'--r',prtime(:,1),pdrf4(:,1),'-g','LineWidth',2)
set(gca,'fontsize',10)
xlabel({'[d] Time (s)'});
ylabel('PDRF risk:Rn (Joules)');
legend(['time step = 1s'],['time step = 2s'],['time step = 3s'],['time step = 4s'])
xlim([0 duration*0.1]);

subplot(3,2,5)
plot(prtime(:,1),TTC,'-r','LineWidth',2)
set(gca,'fontsize',10)
xlabel({'[e] Time(s)'});
ylabel('Time To Collision (s)');
xlim([0 duration*0.1]);ylim([0 10]);

subplot(3,2,6)
plot(prtime(:,1),DATASET(:,1)- DATASET(:,5),'-r','LineWidth',2)
set(gca,'fontsize',10)
xlabel({'[f] Time (s)'});
ylabel('Spacing in (m)');
xlim([0 duration*0.1]);
%}
end
   