clear;
% Set the input limits for ego and neighbour velocity
velocityRange(1)=5; %from 
velocityRange(2)=30; % till
numberofPoints= velocityRange(2)-velocityRange(1)+1; % set the number of points in the range

% Set the input space for ego and neighbour velocity
Vego= linspace(velocityRange(1),velocityRange(2),numberofPoints);
Vneighbour = linspace(velocityRange(1),velocityRange(2),numberofPoints);

% initialise the result struct
result =[];
warningtime_TTC = zeros(numberofPoints,numberofPoints);
warningtime_PDRF = zeros(numberofPoints,numberofPoints);
RISK_MAX= zeros(numberofPoints,numberofPoints);
RISK_MAX_2= zeros(numberofPoints,numberofPoints);
RISK_MAX_3= zeros(numberofPoints,numberofPoints);
RISK_MAX_4= zeros(numberofPoints,numberofPoints);
RISK_MAX_5= zeros(numberofPoints,numberofPoints);
CRASHEVENT= zeros(numberofPoints,numberofPoints);
FALSE_NEGATIVE_COUNTER_iTTC=zeros(numberofPoints,numberofPoints);
FALSE_NEGATIVE_FLAG_iTTC=zeros(numberofPoints,numberofPoints);
FALSE_NEGATIVE_COUNTER_PDRF=zeros(numberofPoints,numberofPoints);
FALSE_NEGATIVE_FLAG_PDRF=zeros(numberofPoints,numberofPoints);
FALSE_POSITIVE_COUNTER_iTTC=zeros(numberofPoints,numberofPoints);
FALSE_POSITIVE_COUNTER_PDRF=zeros(numberofPoints,numberofPoints);
TRUE_POSITIVE_COUNTER_iTTC=zeros(numberofPoints,numberofPoints);
TRUE_POSITIVE_COUNTER_PDRF=zeros(numberofPoints,numberofPoints);
TRUE_NEGATIVE_COUNTER_iTTC=zeros(numberofPoints,numberofPoints);
TRUE_NEGATIVE_COUNTER_PDRF=zeros(numberofPoints,numberofPoints);
iTTC_MAX= zeros(numberofPoints,numberofPoints);
flag_TTC_False=0;
flag_PDRF_False=0;
for i=1:numberofPoints
    for j=1:numberofPoints
        % index of the result =  i-1+j
        % 1,2,3,...1*numberofPoints
        % 1*numberofPoints+1,numberofPoints+2+....2*numberofPoints
        % 2*numberofPoints+1,... and so on
        [result((i-1)*numberofPoints+j).overlaptotal,...
            result((i-1)*numberofPoints+j).ptotal,...
            result((i-1)*numberofPoints+j).pdrf5,...
            result((i-1)*numberofPoints+j).sev,...
            result((i-1)*numberofPoints+j).maxPDRF,...
            result((i-1)*numberofPoints+j).evolution_PDRF,...
            result((i-1)*numberofPoints+j).pdrf1,...
            result((i-1)*numberofPoints+j).pdrf2,...
            result((i-1)*numberofPoints+j).pdrf,...
            result((i-1)*numberofPoints+j).pdrf4,...
            result((i-1)*numberofPoints+j).crashDetection,...
            result((i-1)*numberofPoints+j).maxITTC,...
            result((i-1)*numberofPoints+j).flagtime_TTC,...
            result((i-1)*numberofPoints+j).flagtime_PDRF]= KINETIC_PDRF(Vego(i),Vneighbour(j));
        RISK_MAX_5(i,j)=result((i-1)*numberofPoints+j).maxPDRF(5);
        RISK_MAX(i,j)=result((i-1)*numberofPoints+j).maxPDRF(1); % extracting just the PDRF risk for plotting 
        RISK_MAX_2(i,j)=result((i-1)*numberofPoints+j).maxPDRF(2);
        RISK_MAX_3(i,j)=result((i-1)*numberofPoints+j).maxPDRF(3);
        RISK_MAX_4(i,j)=result((i-1)*numberofPoints+j).maxPDRF(4);
        CRASHEVENT(i,j)=result((i-1)*numberofPoints+j).crashDetection(1); % extracting just the crash detection for plotting 
        iTTC_MAX(i,j)= result((i-1)*numberofPoints+j).maxITTC(1); % extracting just the minTTC for plotting 
        % crash
       if result((i-1)*numberofPoints+j).crashDetection(1,1)==1%there is a collision
            if result((i-1)*numberofPoints+j).flagtime_TTC >0%collision detected
            warningtime_TTC(i,j)= result((i-1)*numberofPoints+j).crashDetection(2,1)-result((i-1)*numberofPoints+j).flagtime_TTC;
                if warningtime_TTC(i,j)<0% time is later than the collision so it fails to detect the danger  
                   FALSE_NEGATIVE_COUNTER_iTTC(i,j)=1;
                   flag_TTC_False=flag_TTC_False+1;
                   FALSE_NEGATIVE_FLAG_iTTC(i,j)=1;
                else
                   TRUE_POSITIVE_COUNTER_iTTC(i,j)=1;
                end
            else% there is a collision but no detection
                FALSE_NEGATIVE_COUNTER_iTTC(i,j)=1;
                warningtime_TTC(i,j)=100;
            end
            if result((i-1)*numberofPoints+j).flagtime_PDRF >0%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            warningtime_PDRF(i,j)= result((i-1)*numberofPoints+j).crashDetection(2,1)-result((i-1)*numberofPoints+j).flagtime_PDRF;
                 if warningtime_PDRF(i,j)<0
                     warningtime_PDRF(i,j)=100;  
                   FALSE_NEGATIVE_COUNTER_PDRF(i,j)=1;
                   flag_PDRF_False=flag_PDRF_False+1;
                   FALSE_NEGATIVE_FLAG_PDRF(i,j)=1;
                 else
                   TRUE_POSITIVE_COUNTER_PDRF(i,j)=1; 
                 end
            else %flagtime_PDRF==0 there is no collision%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% PDRF belongs to this case
                FALSE_NEGATIVE_COUNTER_PDRF(i,j)=1;
                warningtime_PDRF(i,j)=100;
            end
       %no crash%%%%%%%%%%%%%%%%%%%%%%%%%%%%
       else %if result((i-1)*numberofPoints+j).crashDetection(1,1)==0
           if result((i-1)*numberofPoints+j).flagtime_TTC >0
            FALSE_POSITIVE_COUNTER_iTTC(i,j)=1;
            warningtime_TTC(i,j)=100;
           else
            TRUE_NEGATIVE_COUNTER_iTTC(i,j)=1;   
           end
           if result((i-1)*numberofPoints+j).flagtime_PDRF >0
            FALSE_POSITIVE_COUNTER_PDRF(i,j)=1;
            warningtime_PDRF(i,j)=100;
           else
            TRUE_NEGATIVE_COUNTER_PDRF(i,j)=1; 
           end
           warningtime_TTC(i,j)= 100; warningtime_PDRF(i,j)=100;
        end
  
    end
end
FALSE_NEGATIVE_TTC=nnz(FALSE_NEGATIVE_COUNTER_iTTC);
FALSE_NEGATIVE_PDRF=nnz(FALSE_NEGATIVE_COUNTER_PDRF);
FALSE_POSITIVE_TTC=nnz(FALSE_POSITIVE_COUNTER_iTTC);
FALSE_POSITIVE_PDRF=nnz(FALSE_POSITIVE_COUNTER_PDRF);
TRUE_NEGATIVE_TTC=nnz(TRUE_NEGATIVE_COUNTER_iTTC);
TRUE_NEGATIVE_PDRF=nnz(TRUE_NEGATIVE_COUNTER_PDRF);
TRUE_POSITIVE_TTC=nnz(TRUE_POSITIVE_COUNTER_iTTC);
TRUE_POSITIVE_PDRF=nnz(TRUE_POSITIVE_COUNTER_PDRF);

[pos(:,1),pos(:,2)]=find(FALSE_NEGATIVE_COUNTER_PDRF);
%% calculate event matrix
FALSE_NEGATIVE_COUNTER_iTTC(FALSE_NEGATIVE_COUNTER_iTTC==1)=1;%FN crash no warning
FALSE_NEGATIVE_COUNTER_PDRF(FALSE_NEGATIVE_COUNTER_PDRF==1)=1;
FALSE_POSITIVE_COUNTER_iTTC(FALSE_POSITIVE_COUNTER_iTTC==1)=2;%FP no crash, warning
FALSE_POSITIVE_COUNTER_PDRF(FALSE_POSITIVE_COUNTER_PDRF==1)=2;
TRUE_NEGATIVE_COUNTER_iTTC(TRUE_NEGATIVE_COUNTER_iTTC==1)=3;%TP crash warning
TRUE_NEGATIVE_COUNTER_PDRF(TRUE_NEGATIVE_COUNTER_PDRF==1)=3;
TRUE_POSITIVE_COUNTER_iTTC(TRUE_POSITIVE_COUNTER_iTTC==1)=4;%TN no crash no warning
TRUE_POSITIVE_COUNTER_PDRF(TRUE_POSITIVE_COUNTER_PDRF==1)=4;
iTTC(:,:,1)=FALSE_NEGATIVE_COUNTER_iTTC;
iTTC(:,:,2)=FALSE_POSITIVE_COUNTER_iTTC;
iTTC(:,:,3)=TRUE_NEGATIVE_COUNTER_iTTC;
iTTC(:,:,4)=TRUE_POSITIVE_COUNTER_iTTC;

PDRF(:,:,1)=FALSE_NEGATIVE_COUNTER_PDRF;
PDRF(:,:,2)=FALSE_POSITIVE_COUNTER_PDRF;
PDRF(:,:,3)=TRUE_NEGATIVE_COUNTER_PDRF;
PDRF(:,:,4)=TRUE_POSITIVE_COUNTER_PDRF;

for i=1:length(FALSE_NEGATIVE_COUNTER_iTTC(:,1))
    for j=1:length(FALSE_NEGATIVE_COUNTER_iTTC(:,1))
        temp=nonzeros(iTTC(i,j,:));
        iTTCplot(i,j)=temp;
    end
end
for i=1:length(FALSE_NEGATIVE_COUNTER_PDRF(:,1))
    for j=1:length(FALSE_NEGATIVE_COUNTER_PDRF(:,1))
        temp=nonzeros(PDRF(i,j,:));
        PDRFplot(i,j)=temp;
    end
end
%% Figure.9(a)
% Calculate the edge of closed area
y=[];
for i=1:length(CRASHEVENT)
    flag=1;
    for j=1:length(CRASHEVENT)
        if j==1
        temp=CRASHEVENT(j,i);
        else             
            if CRASHEVENT(j,i)~=temp
               if i==1
                   y(end+1,i)=j+4;
               else
                   y(flag,i)=j+4;
                   flag=flag+1;
               end
                temp=CRASHEVENT(j,i);
            end
        end    
    end
end
x=velocityRange(1):velocityRange(2);
for i=1:length(y(:,1))
    eval(['y',num2str(i),'=y(i,:);']);
    eval(['y',num2str(i),'(y',num2str(i),'==0)=[];']);
    eval(['x',num2str(i),'=velocityRange(1):(length(y',num2str(i),')+4);']);
    eval(['y',num2str(i),'c=polyfit(x',num2str(i),',y',num2str(i),',4);']);
    eval(['y',num2str(i),'=polyval(y',num2str(i),'c,x);']);
end
figure;
axis([5 30 5 30]);
hold on
ax1=patch([x fliplr(x)], [y1 min(ylim)*ones(size(y1))], 'g');   % Below Lower Curve
ax2=patch([x fliplr(x)], [y1 max(ylim)*ones(size(y1))], 'r');       % Above Upper Curve
axis([5 30 5 30]);
xlabel('Longitudinal velocity of leading vehicle in m/s') 
ylabel({'Longitudinal velocity','of ego vehicle in m/s'}) 
legend([ax1 ax2],'Without Crashes','With Crashes');
box on;
set(gca,'Layer','top')
%% Figure.9 (b)
% Calculate the edge of closed area
y=[];
for i=1:length(PDRFplot)
    flag=1;
    for j=1:length(PDRFplot)
        if j==1
        temp=PDRFplot(j,i);
        else             
            if PDRFplot(j,i)~=temp
               if i==1
                   y(end+1,i)=j+4;
               else
                   y(flag,i)=j+4;
                   flag=flag+1;
               end
                temp=PDRFplot(j,i);
            end
        end    
    end
end
x=velocityRange(1):velocityRange(2);
for i=1:length(y(:,1))
    eval(['y',num2str(i),'=y(i,:);']);
    eval(['y',num2str(i),'(y',num2str(i),'==0)=[];']);
    eval(['x',num2str(i),'=velocityRange(1):(length(y',num2str(i),')+4);']);
    eval(['y',num2str(i),'c=polyfit(x',num2str(i),',y',num2str(i),',4);']);
    eval(['y',num2str(i),'=polyval(y',num2str(i),'c,x);']);
end
figure;
axis([5 30 5 30]);
hold on
ax1=patch([x fliplr(x)], [y1 fliplr(y2)], 'y');% False positive case
ax2=patch([x fliplr(x)], [y1 min(ylim)*ones(size(y1))], 'g');   % Below Lower Curve
ax3=patch([x fliplr(x)], [y2 max(ylim)*ones(size(y1))], 'r');   % Above Upper Curve
xlabel('Longitudinal velocity of leading vehicle in m/s') 
ylabel({'Longitudinal velocity','of ego vehicle in m/s'}) 
legend([ax3 ax2 ax1],'True positive case','True negative case','False positive case');
box on;
set(gca,'Layer','top')

%% Figure.9 (c)
% Calculate the edge of closed area
y=[];
for i=1:length(iTTCplot)
    flag=1;
    for j=1:length(iTTCplot)
        if j==1
        temp=iTTCplot(j,i);
        else             
            if iTTCplot(j,i)~=temp
               if i==1
                   y(end+1,i)=j+4;
               else
                   y(flag,i)=j+4;
                   flag=flag+1;
               end
                temp=iTTCplot(j,i);
            end
        end    
    end
end
x=velocityRange(1):velocityRange(2);
for i=1:length(y(:,1))
    eval(['y',num2str(i),'=y(i,:);']);
    eval(['y',num2str(i),'(y',num2str(i),'==0)=[];']);
    eval(['x',num2str(i),'=velocityRange(1):(length(y',num2str(i),')+4);']);
    eval(['y',num2str(i),'c=polyfit(x',num2str(i),',y',num2str(i),',4);']);
    eval(['y',num2str(i),'=polyval(y',num2str(i),'c,x);']);
end
figure;
axis([5 30 5 30]);
hold on
ax1=patch([x fliplr(x)], [y1 fliplr(y2)], 'y');% False positive case
ax2=patch([x fliplr(x)], [y1 min(ylim)*ones(size(y1))], 'g');   % Below Lower Curve
ax3=patch([x fliplr(x)], [y2 max(ylim)*ones(size(y1))], 'r');   % Above Upper Curve
xlabel('Longitudinal velocity of leading vehicle in m/s') 
ylabel({'Longitudinal velocity','of ego vehicle in m/s'}) 
legend([ax3 ax2 ax1],'True positive case','True negative case','False positive case');
box on;
set(gca,'Layer','top')