# Usage 
1. Place the four scripts: `MULTISTEP_PDRF.m`, `POSITION.m`, `TR_X5.m` and `TR_Y5.m` , in the same folder 
2. Run `MULTISTEP_PDRF.m` from MATLAB.

## Remarks 
To redefine the trajectory of the neighbouring vehicle, please edit the scripts `TR_X5.m` and `TR_Y5.m`, to redefine the trajectory of the subject vehicle please edit `MULTISTEP_PDRF.m`

# Description of the scripts 
These scripts were used to create `Figure 3` in the following article:

`Mullakkal-Babu, Freddy A., et al. "Probabilistic field approach for motorway driving risk assessment." Transportation research part C: emerging technologies 118 (2020): 102716.`

## ONLINE_SUB_PDRF.m
This script calculates the collision probability of the subject vehicle according to the multi-step prediction scheme. The trajectory of the subject vehicle is defined here.
The set of reachable positions of the NEIGHBOURING VEHICLE and probability associated with the position are fetched from the `POSITION.m` function

+ The resulting figure illustrates the multi-step prediction scheme for vehicle n starting from the initial position [0, 8] ^T and an initial velocity [20, 0] ^T. The black dots
represent the entire set of predicted positions at each prediction time step; the green dots represent the expected positions of at each time step
according to the acceleration plan and variability distribution; and the black line connecting the green dots represents the expected trajectory

## POSITION.m 
This script combines and restructures the prediction matrices from `TR_X5.m` and `TR_Y5.m` so that they are easier to be manipulated during collision probability estimation.
During combination, some predicted states are re-assigned zero probability, the filtered states are the ones infeasible based on non-holonomic constraints 
fetch predicted vehicle states and probabilities along  X and Y-axis.


## TR_X5.m 
This function throws back a matrix of X coordinates of future positions of the `NEIGHBOURING VEHICLE` within the time horizon of 5 seconds, and a matrix of associated discrete probability


## TR_Y5.m 
This function throws back a matrix of Y coordinate of future positions of the `NEIGHBOURING VEHICLE` within the time horizon of 5 seconds, and a matrix of associated discrete probability. This is a copy of the `TR_X5.m`, except that this script deals with variables along Y-axis, and hence look at TR_X5 for missing description. 
