function [YC,Y1, Y2, Y3, Y4, Y5, PY1, PY2, PY3, PY4, PY5, VY1, VY2, VY3, VY4, VY5] = TR_Y5
% This function throws back the a matrix of Y coordinate of
% future positions of the NEIGHBOURING VEHICLE
%within the time horizon of 5 seconds, and a matrix of associated
% discrete probability
% This is exact copy of the TR_X5, except that this script deals with variables along Y axis,
% and hence look at TR_X5 for missing descriptions

ac = 5; % number of discrete time steps
tk = 1; % time step in seconds

% Initialising the matrices containing the Y coordinates of
% future vehicle positions at discrete time steps (1,2,3,..5)
Y0 = zeros(1, 1);
Y1 = zeros(1, ac);
Y2 = zeros(ac^(2 - 1), ac);
Y3 = zeros(ac^(3 - 1), ac);
Y4 = zeros(ac^(4 - 1), ac);
Y5 = zeros(ac^(5 - 1), ac);
j = zeros(ac^(3 - 1), ac);
l = zeros(ac^(3 - 1), ac);

% Initialising the matrices containing the velocity along X axis at
% future vehicle positions at discrete time steps (1,2,3,..5)
VY0 = zeros(1, 1);
VY1 = zeros(1, ac);
VY2 = zeros(ac^(2 - 1), ac);
VY3 = zeros(ac^(3 - 1), ac);
VY4 = zeros(ac^(4 - 1), ac);
VY5 = zeros(ac^(5 - 1), ac);

% Initialising the matrices containing the probabilities of
% future vehicle states at discrete time steps (1,2,3,..5)
PY0 = zeros(1, 1);
PY1 = zeros(1, ac);
PY2 = zeros(ac^(2 - 1), ac);
PY3 = zeros(ac^(3 - 1), ac);
PY4 = zeros(ac^(4 - 1), ac);
PY5 = zeros(ac^(5 - 1), ac);


% discrete acceleration input AY.
AY = zeros(5, ac);
sig = 0.7; % standard deviation of the discretised normal distribution
sig3 = 3 * sig;

% discrete acceleration input AX
AY(:, 3) = -1;

AY(:, 1) = AY(:, 3) - sig3;
% AY(2, 1) = AY(2, 3) - sig3;
% AY(3, 1) = AY(3, 3) - sig3;
% AY(4, 1) = AY(4, 3) - sig3;
% AY(5, 1) = AY(5, 3) - sig3;
AY(:, 2) = AY(:, 3) - sig;
AY(:, 4) = AY(:, 3) + sig;
AY(:, 5) = AY(:, 3) + sig3;
AYC=-1;
% Probability associated with each discrete acceleration input
% derived from discretized normal distribution
PAY = zeros(5, ac);
PAY(:, 1) = 0.004;
PAY(:, 2) = 0.24;
PAY(:, 3) = 0.39;
PAY(:, 4) = 0.24;
PAY(:, 5) = 0.004;

% Intial vehicle state
Y0(1, 1) = 8;
VY0(1, 1) = 0;

% state prediction for tk=1
for c = 1:ac
    Y1(1, c) = Y0(1, 1) + VY0(1, 1) * tk + 0.5 * AY(1, c) * tk * tk;
    PY1(1, c) = PAY(1, c);
end
% V prediction for tk=1
for c = 1:ac
    VY1(1, c) = VY0(1, 1) + AY(1, c) * tk;
end

%state prediction for tk=2
for r = 1:ac
    for c = 1:ac
        if (rem(r, ac) == 0)
            Y2(r, c) = Y1(r/ac, ac) + (VY1(r / ac, ac) * tk) + (0.5 * AY(2, c) * tk * tk);
            PY2(r, c) = PY1(r/ac, ac) * PAY(2, c);
            VY2(r, c) = VY1(r/ac, ac) + (AY(2, c) * tk);
        else if (rem(r, ac) == 1)
                Y2(r, c) = Y1(((r + 4)/ac), ac-4) + (VY1(((r + 4)/ac), ac - 4) * tk) + (0.5 * AY(2, c) * tk * tk);
                PY2(r, c) = PY1(((r + 4)/ac), ac-4) * PAY(2, c);
                VY2(r, c) = VY1(((r + 4)/ac), ac-4) + (AY(2, c) * tk);
            else if (rem(r, ac) == 2)
                    Y2(r, c) = Y1(((r + 3)/ac), ac-3) + (VY1(((r + 3)/ac), ac - 3) * tk) + (0.5 * AY(2, c) * tk * tk);
                    PY2(r, c) = PY1(((r + 3)/ac), ac-3) * PAY(2, c);
                    VY2(r, c) = VY1(((r + 3)/ac), ac-3) + (AY(2, c) * tk);
                else if (rem(r, ac) == 3)
                        Y2(r, c) = Y1(((r + 2)/ac), ac-2) + (VY1(((r + 2)/ac), ac - 2) * tk) + (0.5 * AY(2, c) * tk * tk);
                        PY2(r, c) = PY1(((r + 2)/ac), ac-2) * PAY(2, c);
                        VY2(r, c) = VY1(((r + 2)/ac), ac-2) + (AY(2, c) * tk);
                    else if (rem(r, ac) == 4)
                            Y2(r, c) = Y1(((r + 1)/ac), ac-1) + (VY1(((r + 1)/ac), ac - 1) * tk) + (0.5 * AY(2, c) * tk * tk);
                            PY2(r, c) = PY1(((r + 1)/ac), ac-1) * PAY(2, c);
                            VY2(r, c) = VY1(((r + 1)/ac), ac-1) + (AY(2, c) * tk);
                        end
                    end
                end
            end
        end
    end
end

%X prediction for tk=3
for r = 1:ac * ac
    for c = 1:ac
        if (rem(r, ac) == 0)
            Y3(r, c) = Y2(r/ac, ac) + (VY2(r / ac, ac) * tk) + (0.5 * AY(3, c) * tk * tk);
            PY3(r, c) = PY2(r/ac, ac) * PAY(3, c);
            VY3(r, c) = VY2(r/ac, ac) + (AY(3, c) * tk);
        else if (rem(r, ac) == 1)
                Y3(r, c) = Y2(((r + 4)/ac), ac-4) + (VY2(((r + 4)/ac), ac - 4) * tk) + (0.5 * AY(3, c) * tk * tk);
                PY3(r, c) = PY2(((r + 4)/ac), ac-4) * PAY(3, c);
                VY3(r, c) = VY2(((r + 4)/ac), ac-4) + (AY(3, c) * tk);
            else if (rem(r, ac) == 2)
                    Y3(r, c) = Y2(((r + 3)/ac), ac-3) + (VY2(((r + 3)/ac), ac - 3) * tk) + (0.5 * AY(3, c) * tk * tk);
                    PY3(r, c) = PY2(((r + 3)/ac), ac-3) * PAY(3, c);
                    VY3(r, c) = VY2(((r + 3)/ac), ac-3) + (AY(3, c) * tk);
                else if (rem(r, ac) == 3)
                        Y3(r, c) = Y2(((r + 2)/ac), ac-2) + (VY2(((r + 2)/ac), ac - 2) * tk) + (0.5 * AY(3, c) * tk * tk);
                        PY3(r, c) = PY2(((r + 2)/ac), ac-2) * PAY(3, c);
                        VY3(r, c) = VY2(((r + 2)/ac), ac-2) + (AY(3, c) * tk);
                    else if (rem(r, ac) == 4)
                            Y3(r, c) = Y2(((r + 1)/ac), ac-1) + (VY2(((r + 1)/ac), ac - 1) * tk) + (0.5 * AY(3, c) * tk * tk);
                            PY3(r, c) = PY2(((r + 1)/ac), ac-1) * PAY(3, c);
                            VY3(r, c) = VY2(((r + 1)/ac), ac-1) + (AY(3, c) * tk);
                        end
                    end
                end
            end
        end
    end
end

%X prediction for tk=4
for r = 1:ac * ac * ac
    for c = 1:ac
        if (rem(r, ac) == 0)
            Y4(r, c) = Y3(r/ac, ac) + (VY3(r / ac, ac) * tk) + (0.5 * AY(4, c) * tk * tk);
            PY4(r, c) = PY3(r/ac, ac) * PAY(4, c);
            VY4(r, c) = VY3(r/ac, ac) + (AY(4, c) * tk);
        else if (rem(r, ac) == 1)
                Y4(r, c) = Y3(((r + 4)/ac), ac-4) + (VY3(((r + 4)/ac), ac - 4) * tk) + (0.5 * AY(4, c) * tk * tk);
                PY4(r, c) = PY3(((r + 4)/ac), ac-4) * PAY(4, c);
                VY4(r, c) = VY3(((r + 4)/ac), ac-4) + (AY(4, c) * tk);
            else if (rem(r, ac) == 2)
                    Y4(r, c) = Y3(((r + 3)/ac), ac-3) + (VY3(((r + 3)/ac), ac - 3) * tk) + (0.5 * AY(4, c) * tk * tk);
                    PY4(r, c) = PY3(((r + 3)/ac), ac-3) * PAY(4, c);
                    VY4(r, c) = VY3(((r + 3)/ac), ac-3) + (AY(4, c) * tk);
                else if (rem(r, ac) == 3)
                        Y4(r, c) = Y3(((r + 2)/ac), ac-2) + (VY3(((r + 2)/ac), ac - 2) * tk) + (0.5 * AY(4, c) * tk * tk);
                        PY4(r, c) = PY3(((r + 2)/ac), ac-2) * PAY(4, c);
                        VY4(r, c) = VY3(((r + 2)/ac), ac-2) + (AY(4, c) * tk);
                    else if (rem(r, ac) == 4)
                            Y4(r, c) = Y3(((r + 1)/ac), ac-1) + (VY3(((r + 1)/ac), ac - 1) * tk) + (0.5 * AY(4, c) * tk * tk);
                            PY4(r, c) = PY3(((r + 1)/ac), ac-1) * PAY(4, c);
                            VY4(r, c) = VY3(((r + 1)/ac), ac-1) + (AY(4, c) * tk);
                        end
                    end
                end
            end
        end
    end
end

%X prediction for tk=5
for r = 1:ac * ac * ac * ac
    for c = 1:ac
        if (rem(r, ac) == 0)
            Y5(r, c) = Y4(r/ac, ac) + (VY4(r / ac, ac) * tk) + (0.5 * AY(5, c) * tk * tk);
            PY5(r, c) = PY4(r/ac, ac) * PAY(5, c);
            VY5(r, c) = VY4(r/ac, ac) + (AY(5, c) * tk);
        else if (rem(r, ac) == 1)
                Y5(r, c) = Y4(((r + 4)/ac), ac-4) + (VY4(((r + 4)/ac), ac - 4) * tk) + (0.5 * AY(5, c) * tk * tk);
                PY5(r, c) = PY4(((r + 4)/ac), ac-4) * PAY(5, c);
                VY5(r, c) = VY4(((r + 4)/ac), ac-4) + (AY(5, c) * tk);
            else if (rem(r, ac) == 2)
                    Y5(r, c) = Y4(((r + 3)/ac), ac-3) + (VY4(((r + 3)/ac), ac - 3) * tk) + (0.5 * AY(5, c) * tk * tk);
                    PY5(r, c) = PY4(((r + 3)/ac), ac-3) * PAY(5, c);
                    VY5(r, c) = VY4(((r + 3)/ac), ac-3) + (AY(5, c) * tk);
                else if (rem(r, ac) == 3)
                        Y5(r, c) = Y4(((r + 2)/ac), ac-2) + (VY4(((r + 2)/ac), ac - 2) * tk) + (0.5 * AY(5, c) * tk * tk);
                        PY5(r, c) = PY4(((r + 2)/ac), ac-2) * PAY(5, c);
                        VY5(r, c) = VY4(((r + 2)/ac), ac-2) + (AY(5, c) * tk);
                    else if (rem(r, ac) == 4)
                            Y5(r, c) = Y4(((r + 1)/ac), ac-1) + (VY4(((r + 1)/ac), ac - 1) * tk) + (0.5 * AY(5, c) * tk * tk);
                            PY5(r, c) = PY4(((r + 1)/ac), ac-1) * PAY(5, c);
                            VY5(r, c) = VY4(((r + 1)/ac), ac-1) + (AY(5, c) * tk);
                        end
                    end
                end
            end
        end
    end
end
YC=zeros(1,ac);
for i=1:(ac+1)
    if i==1
       YC(1,i)=Y0(1,1);     
    else
       YC(1,i)=Y0(1,1)+VY0(1,1)*(i-1)*tk+0.5*AYC*((i-1)*tk)^2;
    end
end
end
