clear all;
vehicledata=xlsread('MPDRF_VEH.xlsx');
pdrfdata=xlsread('MPDRF_RISK.xlsx');

figure
subplot(2,2,1)
set(gca,'fontsize',10)
yyaxis left
plot(vehicledata(:,1),vehicledata(:,2),':k',vehicledata(:,1),vehicledata(:,3),':r',vehicledata(:,1),vehicledata(:,4),':g','LineWidth',2)
set(gca,'fontsize',10)
xlabel({'Prediction time in s ','[a]'});
ylabel('Crash probability with n1','color','black');
yyaxis right
plot(vehicledata(:,1),vehicledata(:,5),'-k',vehicledata(:,1),vehicledata(:,6),'-r',vehicledata(:,1),vehicledata(:,7),'-g','LineWidth',2)
set(gca,'fontsize',10)
ylabel('Crash severity with n1 in Joules','color','black');
legend(['T1 Crash probability'],['T2 Crash probability'],['T3 Crash probability'],['T1 severity'],['T2 severity'],['T3 severity'])

subplot(2,2,2)
set(gca,'fontsize',10)
yyaxis left
plot(vehicledata(:,1),vehicledata(:,9),':k',vehicledata(:,1),vehicledata(:,10),':r',vehicledata(:,1),vehicledata(:,11),':g','LineWidth',2)
set(gca,'fontsize',10)
xlabel({'Prediction time in s ','[b]'});
ylabel('Crash probability with n2','color','black');
yyaxis right
plot(vehicledata(:,1),vehicledata(:,12),'-k',vehicledata(:,1),vehicledata(:,13),'-r',vehicledata(:,1),vehicledata(:,14),'-g','LineWidth',2)
set(gca,'fontsize',10)
ylabel('Crash severity with n2 in Joules ','color','black');
legend(['T1 Crash probability'],['T2 Crash probability'],['T3 Crash probability'],['T1 severity'],['T2 severity'],['T3 severity'])

subplot(2,2,3)
set(gca,'fontsize',10)
yyaxis left
plot(vehicledata(:,1),vehicledata(:,16),':k','LineWidth',2)
set(gca,'fontsize',10)
xlabel({'Prediction time in s ','[c]'});
ylabel({'Artificial crash probability',' with right lane marking'},'color','black');
yyaxis right
plot(vehicledata(:,1),vehicledata(:,17),'-k','LineWidth',2)
set(gca,'fontsize',10)
ylabel({'Arificial Crash severity ','with right lane marking in Joules '},'color','black');
legend(['T4 Crash probability'],['T4 Severity'])


subplot(2,2,4)
set(gca,'fontsize',10)
yyaxis left
plot(pdrfdata(:,1),pdrfdata(:,2),'-k',pdrfdata(:,1),pdrfdata(:,4),'-g',pdrfdata(:,1),pdrfdata(:,5),'-b','LineWidth',2)
set(gca,'fontsize',10)
xlabel({'Prediction time in s ','[d]'});
xlim([1 4])
ylabel('PDRF Risk in joules','color','black');
yyaxis right
plot(pdrfdata(:,1),pdrfdata(:,3),'-r','LineWidth',2)
set(gca,'fontsize',10)
ylabel('PDRF Risk in Joules','color','black');
legend(['T1'],['T3'],['T4'],['T2 right y axis'])

figure
set(gca,'fontsize',10)
xaxis = categorical({'T1','T2','T3','T4'});
yaxis = [pdrfdata(5,2) pdrfdata(5,3) pdrfdata(5,4) pdrfdata(5,5)];
bar(xaxis, yaxis)
set(gca,'fontsize',15)
ylim([2 5])
ylabel({'Generalised TTC (s) '});
xlabel('Trajectory plan');



