# Usage 
1. Place the four scripts: `MAIN_5.m`, `MAIN_6_7.m`, `C_PROB.m`, `reachable.m` ,`roadBoundaryEncounter.xlsx` , `encounter6.xlsx` and `encounter7.xlsx`in one folder. 
2. Run `MAIN_5.m` from MATLAB to create figure 5 
3. RUN `MAIN_6_7.m` to create Figure 6 and 7. Follow the instructions in line 2 and 4 to choose between the two figures. 

# Description of the scripts 
These scripts were used to create `Figure 8` and `Figure 9` in the following article:

`Mullakkal-Babu, Freddy A., et al. "Probabilistic field approach for motorway driving risk assessment." Transportation research part C: emerging technologies 118 (2020): 102716.`

## MAIN_5.m
+ This calculates the single-step PDRF risk of an encounter in which the subject vehicle avoids a crash with the right lane boundary by corrective steering.
+ The trajectories of the two vehicles are obtained from `roadBoundaryEncounter.xlsx`. 
+ This function calls two helper functions: `reachable.m` and `C_PROB.m`

## MAIN_6-7.m
+ This calculates the single-step PDRF risk of the ego with the neighbouring vehicle. 
+ The trajectories of the two vehicles are obtained from `encounter6.xlsx` for Figure 6 and `encounter7.xlsx` for figure 7. 
+ This function calls two helper functions: `reachable.m` and `C_PROB.m`

## C_PROB.m
This function calculates the crash probability between two vehicles at a given future time step. This function calls the helper `reachable.m` to estimate the reachable region of a vehicle. 

## reachable.m
This function calculates the reachable region of a vehicle at a future time step, based on its initial kinematic state and vehicle dynamics constraints. 

## .xlsx files
These are trajectory samples from three near-crash events selected from 100 vehicles naturalistic study dataset. 
The `roadBoundaryEncounter.xlsx` corresponds to trip number 8299;  `encounter6.xlsx` corresponds to trip number 8450, and `encounter7.xlsx` corresponds to trip number 8424

The xlsx file contains the following columns
1. X: Longitudinal position of the subject in m
2. Y: Lateral position of the subject in m
 3. VX: Longitudinal velocity of the subject in m/s
4. VY: Lateral velocity of subject in m/s
 5. Longitudinal position of leader in m
6. Lateral position of leader in m
7. Longitudinal velocity of leader in m/s
 8. Lateral velocity of leader in m/s
